#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "auto.h"

using namespace std;

//------------------------------------------------------------
Auto::Auto(std::string marke, bool busena) {
  this->marke=marke;
  this->busena=busena;
}
//------------------------------------------------------------
Auto::~Auto() {
  list<Sutartis*>::iterator i;
   for (i = sutartis.begin();  i != sutartis.end();  i++)
       delete (*i);
       sutartis.clear();
}
//------------------------------------------------------------
string Auto::getAuto() {
  return(marke);
}
//------------------------------------------------------------
bool Auto::getBusena() {
  return(busena);
}
//------------------------------------------------------------
bool Auto::setBusena() {
  busena=true;
  return(busena);
}
//------------------------------------------------------------
bool Auto::unsetBusena() {
  busena=false;
  return(busena);
}
//------------------------------------------------------------
void Auto::printAuto() {
  string nuoma="laisvas";

  if(getBusena())
    nuoma="isnuomotas";
  else
    nuoma;

  cout<<marke<<":\t ["<<nuoma<<"]"<<endl;
  list<Sutartis*>::iterator i=sutartis.begin();
  for(; i!=sutartis.end(); i++)
     cout<<"\t\tSumoketa: "<<(*i)->getPinigai()<<"\tData: "<<(*i)->getDate()<<endl;
  cout<<endl;
}
//------------------------------------------------------------
int Auto::printAutoPelnas(std::string nuo, std::string iki) {
  int suma=0;
  list<Sutartis*>::iterator i=sutartis.begin();
  for(; i!=sutartis.end(); i++)
     if((nuo <= (*i)->getDate()) && ((*i)->getDate() <= iki))
        suma+=(*i)->getPinigai();
  return suma;
}
//------------------------------------------------------------
int Auto::printVisaPelna() {
  int suma=0;
  list<Sutartis*>::iterator i=sutartis.begin();
  for(; i!=sutartis.end(); i++)
      suma+=(*i)->getPinigai();
  return suma;
}
//------------------------------------------------------------
void Auto::iSarasa(int pinigai, std::string date) {
  sutartis.push_back(new Sutartis(pinigai, date));
}
//------------------------------------------------------------
void Auto::autoToFile(std::ofstream& outFile) {
  string nuoma="laisvas";

  if(getBusena())
    nuoma="isnuomotas";
  else
    nuoma;

  outFile<<marke<<":\t ["<<nuoma<<"]"<<endl;
  list<Sutartis*>::iterator i=sutartis.begin();
  for(; i!=sutartis.end(); i++)
     outFile<<"\t\tSumoketa: "<<(*i)->getPinigai()<<"\tData: "<<(*i)->getDate()<<endl;
}
//------------------------------------------------------------

