#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "autolist.h"

using namespace std;

//------------------------------------------------------------
AutoList::~AutoList() {
   list<Auto*>::iterator vi;
   for (vi = autoList.begin();  vi != autoList.end();  vi++)
       delete (*vi);           // delete Auto objektus
       autoList.clear();       // delete Auto nuorodas (pointers)
}
//------------------------------------------------------------
void AutoList::printSarasa() {
   cout << "====================================================" << endl;
   autoList.sort(Palyginti());
   list<Auto*>::iterator vi = autoList.begin();

   for (;  vi != autoList.end();  vi++)
      (*vi)->printAuto();
   cout << "====================================================" << endl;
}
//------------------------------------------------------------
void AutoList::isnuomoti() {
   string marke;
   bool busena;
   int pinigai;
   string data;
   cout << "Kurios markes auto norite isnuomuoti: ";
   cin >> marke;
   cout << "Data (MMMM-mm-dd): ";
   cin >> data;
   cout << "Pinigai: ";
   cin >> pinigai;

    list<Auto*>::iterator iter = autoList.begin();
      for (;  iter != autoList.end();  iter++) {
      string markeX = (*iter)->getAuto();
         if (markeX == marke) {
           if((*iter)->getBusena() == false) {
              (*iter)->setBusena();
              (*iter)->iSarasa(pinigai,data);
              break;
           }else
              cout<<"Siuo metu automobilis isnuomotas"<<endl;
         }
      }
}
//------------------------------------------------------------
void AutoList::atsiimti() {
   string marke;
   cout << "Kurios markes auto norite atsiimti? ";
   cin >> marke;
   list<Auto*>::iterator iter = autoList.begin();
      for (;  iter != autoList.end();  iter++) {
      string markeX = (*iter)->getAuto();
         if (markeX == marke) {
            (*iter)->unsetBusena();
            break;
         }
      }
}
//------------------------------------------------------------
void AutoList::createNewAuto(std::string marke, bool busena) {
   autoList.push_back(new Auto(marke, busena));
}
//------------------------------------------------------------
void AutoList::printLaikotarpi() {
   string dataNuo;
   string dataIki;
   int i=0,pelnas=0;
   cout << "Nuo kada (MMMM-mm-dd): ";
   cin >> dataNuo;
   cout << "Iki kada (MMMM-mm-dd): ";
   cin >> dataIki;
   list<Auto*>::iterator iter = autoList.begin();
   for (;  iter != autoList.end();  iter++){
      i=(*iter)->printAutoPelnas(dataNuo, dataIki);
      pelnas=pelnas+i;
   }
   cout<<"Pelnas: "<<pelnas<< "Lt"<<endl;
}
//------------------------------------------------------------
void AutoList::printPelna() {
   string dataNuo;
   string dataIki;
   int i=0,pelnas=0;
   list<Auto*>::iterator iter = autoList.begin();
   for (;  iter != autoList.end();  iter++){
      i=(*iter)->printVisaPelna();
      pelnas=pelnas+i;
   }
   cout<<"Bendras pelnas: "<<pelnas<<" Lt"<<endl;
}
//------------------------------------------------------------
void AutoList::printVienaSarasa(){
   string marke;
   cout << "Nurodykite auto marke: ";
   cin >> marke;
   list<Auto*>::iterator iter = autoList.begin();
   for (;  iter != autoList.end();  iter++) {
      string markeX = (*iter)->getAuto();
      if (markeX == marke)
         (*iter)->printAuto();
   }
}
//------------------------------------------------------------
void AutoList::toFile() {
   ofstream outFile("output.txt");
   autoList.sort(Palyginti());
   list<Auto*>::iterator vi = autoList.begin();
   for (;  vi != autoList.end();  vi++)
      (*vi)->autoToFile(outFile);
   outFile.close();
}
//------------------------------------------------------------


